%% Winter 2019 PHYS 178/278 HW1 Prob. 2

% Please use 'Run Section' to execute the code.

%% Prob 2.1  Probability of gateing variables & time constant
clear all

am   = @(V) (-0.1*V + 2.5)./(exp(-0.1.*V + 2.5) - 1);     
bm   = @(V) 4*exp(-V./18);
% m_eq = @(V) ????; % Please fill in m_eq  in terms of am (V) and bm (V)!!!
% tau_m= @(V) ????; % Please fill in tau_m in terms of am (V) and bm (V)!!!


% an   = ???;    
% bn   = ???;
% n_eq = ???;
% tau_n= ???;


% ah   = ???;                    
% bh   = ???;
% h_eq = ???;
% tau_h= ???;


V = -100:.05:150;  % Define the range of voltage


figure(1)
subplot(2,1,1) % Plot the voltage gating variables

plot(V, m_eq(V), 'Linewidth',2)
%plot(V, m_eq(V), V, n_eq(V), V, h_eq(V), 'Linewidth',2)
ylabel('Probability of opining',     'FontSize', 15)
legend({'m_{eq}'}, 'FontSize', 16)


subplot(2,1,2) % Plot the time constant

plot(V, tau_m(V),'Linewidth',2)
%plot(V, tau_m(V), V, tau_n(V), V, tau_h(V),'Linewidth',2)
xlabel('Voltage (mV)',               'FontSize', 15) 
ylabel('Time constent (ms)',         'FontSize', 15)
legend({'\tau_{m}'},'FontSize', 16)



%% Prob 2.2 Simulate Hodgkin and Huxley neuron (with file HHmodel.m)
% Include the HHModel.m file in the same folder.
% Fill in all the missing code lines before executing the codes.

clear all

% The length of time that we want to simulate, in unit of msec.
% [Uncommand next line. Tune the time legnth you want to simulate!!!]
% T = ???;  % ex, T = 150


% Constent Input Current [Try to tune differnet currents!]
I_current = 8; 

% Initial values of V(t), n(t), m(t), h(t), I(t) at t = 0 
% [Try different initial values!!!]
initial = [0.00362, 0.0530, 0.3177, 0.5960];


% Use the build in ordinary differential equation solver ode45(...)
[t, y] = ode45(@(t, y) HHModel(t, y, I_current), [0  T], initial);


% Get the V(t), m(t), n(t), h(t)
V = y(:,1);
m = y(:,2);
n = y(:,3);
h = y(:,4);


% Plot V(t)
figure(2)
subplot(2,1,1);
plot(t,V); hold on

ylabel('Voltage (mV)', 'FontSize',15) 
xlabel('Time t (ms)',  'FontSize',15) 
title(['Input Current = ', num2str(I_current), ' nA' ], ...
       'FontWeight', 'bold', 'FontSize', 14)


% Plot n(t), m(t), h(t)
subplot(2,1,2);
plot(t,m,t,n,t,h)

legend({'m', 'n', 'h'},'FontSize',15)
xlabel('Time t (ms)',  'FontSize',15) 
hold off


%% Prob. 2.3 Explore the frequency of the pulses as a function of current. 
% % Hints: findpeaks(data) returns a vector with the local maxima (peaks) of
% %        the input signal vector, data. 
% %       
% %        length(X) returns the number of elements in vectors X.
%
% 
% % Ex: Uncommand and run the follwoing codes (you need to run the code for 
% %     Prob. 2.2 first), and see what it gives you.
%
findpeaks(y(:,1), 'minpeakheight', 60)
length(findpeaks(y(:,1), 'minpeakheight', 25))
%
% % To get more info about the two MATLAB functions, yon can type the
% % following lines in the Command Window
%
% help findpeaks
% help length


%% Try to finish the follwoing codes, or write one by yourself!

clear all

% Set a range of current inputs
I_current = 5:0.05:20;  

% Preallocated a vector for storing the spike counts
N_spikes  = zeros(1, length(I_current)); 

% Initial values of V(t), n(t), m(t), h(t), I(t) at t = 0
% [Uncommand next line and fill in the initial values!!!]
%initial = ???;


% [Set the time length that you wnat to simulate (mini sec.)!!!
%  Ex: T = 1000, 2000 or 3000]
%T = ???;


for i = 1:length(I_current)
    
    % [Uncommand next line, and finish the missing variables!!!]
    %[t, y] = ode45(@(t, y) HHModel(t, y, I_current(i)), [??  ??], ???);
    
    
    % Cunts # of peaks
    N_spikes(i) = length(findpeaks(y(:,1), 'minpeakheight', 50));
    
end

% Plot F VS I for HHmodel
figure(3)
plot(I_current, N_spikes/T,'Linewidth',2)

set(h,'Marker', '.', 'MarkerEdgeColor', 'k')
set(h,'MarkerSize',15);
% ylabel('set your xlael',  'FontSize',15) 
% xlabel('set your ylael',  'FontSize',15)
% title( 'set your title',  'FontSize',16)
hold on



%% Prob 2.4 STA of HHmodel
clear all
rng('shuffle')

% Prob 2.4 Part(1) Generate the white Gaussian noise current inputs

% The length of time that we want to simulate.
% [Tune the time legnth you want to simulate!!!]
%T = ???; %(msec)


% Time steps for sampling. 
% [Uncommand next line and adjust sampled time steps!!!]
%idt = ???;      % Sampled time steps
tt = 0:idt:T;

% Samples of white gaussian noise. 
% [Uncommand next line and adjust the power of noise samples!!!]
%I_in = wgn(length(tt), 1, power???); 


%% Prob 2.4 Part(2) Solve the differential equation with Euler method runHHModel(....)

% Initial values of V(t), n(t), m(t), h(t) at t = 0 
% [Uncommand next line and fill in the initial values!!!!!!]
%initial = ???;


% Make sure to include the HHModel.m and runHHModel.m file in the same folder.
[t, y] = runHHModel(T, initial, tt, I_in); % Feed the I_in into a HH neuron.

V = y(:,1);
m = y(:,2);
n = y(:,3);
h = y(:,4);

% Plot membrane voltage V(t)
figure(4)
subplot(2,1,1)
plot(t,V); hold on

ylabel('Voltage (mV)', 'FontSize',15) 
xlabel('Time t (ms)',  'FontSize',15) 

% Plot input current I(t)
subplot(2,1,2)
plot(tt, I_in)
ylabel('Input current I(t) (nA)', 'FontSize',15)
xlabel('Time t (ms)',  'FontSize',15) 
hold off


%% Part(3) Example: Compute the STA over the range of 30 msec before the spike

%  Find the indices of all spikes 
[~, locs] = findpeaks(y(:, 1), 'minpeakheight', 50);
plot(t(locs), ones(size(locs)),'r.')


% We are going to calculate the STA over the time window of 30ms
dt = t(2) - t(1);   % the size of each time step
%sta_setps =  ???;  % the number of steps within 30 ms time window


% Drop the spike-time indices that are between 0 to 30 msec.
locs = locs(locs > sta_setps);

% Drop the spike-time indices that are in the last 30 msec.
%locs = locs(locs < length(t) - sta_setps);


%%
spk_I = zeros(length(locs), sta_setps); % Each row vector is a size of 
                                        % (sta_setps) stimulus sample 
                                        % that comes before a spike.
                                        
spk_V = zeros(length(locs), sta_setps); % Each row vector is a 
                                        % (sta_setps) volage values 
                                        % that comes before a spike.
intI = interp1(tt, I_in, t);


for i = 1:length(locs)
    
    loc = locs(i);    
    spk_I(i, :) = intI(loc - sta_setps + 1: loc)';    
    spk_V(i, :) =    V(loc - sta_setps + 1: loc)';
    
end


% Plot STA of input current and membrane voltage

%staI = ???; % Average all stimulus samples to get STA!!!
%staV = ???; % Average all stimulus samples to get STA!!!
           
           % Hint: you may need the build-in functions
           %       1) sum(..., ...) / (total number of samples), or
           %       2) mean(..., ...)
           %
           % In the Command Window, type the following lines to see more
           % examples for the two functions
           % >> help sum
           % >> help mean


t_step = (-sta_setps + 1:0)*dt;

figure(5)
subplot(2,1,1)
plot(t_step, staI)
ylabel('Current (nA)', 'FontSize',15) 
title('Spike triggered averaged ', ...
       'FontWeight', 'bold', 'FontSize', 15)

subplot(2,1,2)
plot(t_step, staV)
ylabel('Membrane Voltage (mV)', 'FontSize',15) 
xlabel('Time relative to spike (ms)',  'FontSize',15) 


%% Compute the STA over the range of 30 msec BEFORE and AFTER the spike (60 msec totall)

% Please try to modified the code provided from the previous example!!!





%% Prob 2.5  F(I) VS I curve of of Leaky integrate & fire (LIF) neuron

I_in = 0:0.001:5; 

% Please solve the F(I) as function of input I.
%f_LIF = @(I) ??? ;

figure(3)
subplot(1,2,2)
plot(I_in, f_LIF(I_in), 'Linewidth',2, 'Color', 'k') % Plot F VS I for LIF model

xlabel('Current  I',              'FontSize',15)
title('Prob. 2.5  F vs I (LIF)',  'FontSize',16)
hold off

